#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	mesa
Version		:	24.2.6
Release		:	17.2.0.rel%{?dist}
summary		:	Mesa graphics libraries
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://mesa.freedesktop.org
			# https://archive.mesa3d.org/

Source0		:	%{name}-%{version}.tar.xz
Patch0		:	%{name}-%{version}-add_xdemos-3.patch 

#-----------------------------------------------------------------------------
BuildRequires	:	cbindgen
BuildRequires	:	elfutils-devel
BuildRequires	:	gettext
BuildRequires	:	glslang-devel
BuildRequires	:	libclc-devel
BuildRequires	:	libdrm	>= 2.4.121
BuildRequires	:	libunwind-devel
# libva-bootstrap-devel, To allow Gallium va frontend
BuildRequires   :       libva-bootstrap-devel
BuildRequires	:	libvdpau
BuildRequires	:	llvm-devel
BuildRequires	:	llvm-clang-devel
BuildRequires	:	make-ca
BuildRequires	:	meson
BuildRequires	:	SPIRV-Tools-devel
BuildRequires	:	SPIRV-LLVM-Translator-devel
BuildRequires	:	python3-Mako
BuildRequires	:	python3-MarkupSafe
BuildRequires	:	python-ply
BuildRequires	:	python3-pyyaml
BuildRequires	:	rustc
BuildRequires	:	rust-bindgen
BuildRequires	:	valgrind-devel
BuildRequires	:	xorg-libxshmfence
BuildRequires	:	xorg-libXrandr
BuildRequires	:	xorg-libX11,xorg-libXext,xorg-libXdamage,xorg-libXfixes
BuildRequires	:	Vulkan-Loader
BuildRequires	:	wayland,wayland-protocols
BuildRequires	:	xcb-util-keysyms
BuildRequires	:	xorg-libXxf86vm
BuildRequires	:	xorg-libXvMC

Requires	:	mesa-dri-drivers	=  %{version}
Requires	:	mesa-libd3d		=  %{version}
Requires	:	mesa-libglapi		=  %{version}
Requires	:	mesa-libGLES		=  %{version}
Requires	:	mesa-libEGL		=  %{version}
Requires	:	mesa-libGL		=  %{version}
Requires	:	mesa-libgbm		=  %{version}
Requires	:	mesa-libxatracker	=  %{version}
Requires	:	mesa-libOSMesa		=  %{version}
Requires	:	mesa-vulkan-drivers	=  %{version}
Requires	:	wayland
#-----------------------------------------------------------------------------
%description
Mesa graphics libraries

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%{_bindir}/glxgears
%{_bindir}/glxinfo
%{_mandir}/man1/glx*.1.gz

#=============================================================================
%package		devel

Summary		:	groupp all mesa devel package

#-----------------------------------------------------------------------------
Requires	:	%{name}-dri-drivers
Requires	:	%{name}			=  %{version}

Requires	:	mesa-libd3d-devel	=  %{version}
Requires	:	mesa-libGLES-devel	=  %{version}
Requires	:	mesa-libEGL-devel	=  %{version}
Requires	:	mesa-libGL-devel	=  %{version}
Requires	:	mesa-libgbm-devel	=  %{version}
Requires	:	mesa-libxatracker-devel	=  %{version}
Requires	:	mesa-libOSMesa-devel	=  %{version}

#-----------------------------------------------------------------------------
%description		devel
%{summary}

#-----------------------------------------------------------------------------
%files			devel

#=============================================================================
%package		libd3d

Summary		:	Mesa Direct3D9 state tracker

#-----------------------------------------------------------------------------
%description		libd3d
%{summary}

#-----------------------------------------------------------------------------
%files			libd3d
%defattr(-,root,root,-)
%{_libdir}/d3d/*.so.1*


#=============================================================================
%package		libd3d-devel

Summary		:	Mesa Direct3D9 state tracker development package

Requires	:	%{name}-libd3d		=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libd3d-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libd3d-devel
%defattr(-,root,root,-)
%{_includedir}/d3dadapter/*.h
%{_libdir}/d3d/*.so
%{_libdir}/pkgconfig/d3d.pc

#=============================================================================
%package		dri-drivers

Summary		:	Mesa-based DRI drivers

#-----------------------------------------------------------------------------
%description		dri-drivers
%{summary}

#-----------------------------------------------------------------------------
%files			dri-drivers
%defattr(-,root,root,-)
%{_libdir}/dri/*.so
%{_libdir}/vdpau/*
%{_libdir}/libgallium-%{version}.so
%{_datadir}/drirc.d/00-mesa-defaults.conf

#=============================================================================
%package		libglapi

Summary		:	Mesa shared glapi

Requires	:	%{name}-dri-drivers	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libglapi
%{summary}

#-----------------------------------------------------------------------------
%files			libglapi
%defattr(-,root,root,-)
%{_libdir}/libglapi.so.0*

#=============================================================================
%package		libGLES

Summary		:	Mesa libGLES runtime libraries

#-----------------------------------------------------------------------------
%description		libGLES
%{summary}

#-----------------------------------------------------------------------------
%files			libGLES
%defattr(-,root,root,-)
%{_libdir}/libGLESv1_CM.so.1*
%{_libdir}/libGLESv2.so.2*

#=============================================================================
%package		libGLES-devel
Summary		:	Mesa libGLES development package

#-----------------------------------------------------------------------------
Requires	:	%{name}-libGLES		=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libGLES-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libGLES-devel
%defattr(-,root,root,-)
%{_includedir}/GLES*/*.h
%{_libdir}/libGLES*.so
%{_libdir}/pkgconfig/gles*.pc

#=============================================================================
%package		libEGL

Summary		:	Mesa libEGL runtime libraries

Requires	:	%{name}-libgbm		=	%{version}-%{release}
Requires	:	%{name}-libglapi	=	%{version}-%{release}
Requires	:	%{name}-dri-drivers	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libEGL
%{summary}

#-----------------------------------------------------------------------------
%files			libEGL
%defattr(-,root,root,-)
#Provided by also by libglvnd-glx?
%{_libdir}/libEGL.so.1*

#=============================================================================
%package		libEGL-devel
Summary		:	Mesa libEGL development package

#-----------------------------------------------------------------------------
Requires	:	%{name}-libEGL		=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libEGL-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libEGL-devel
%defattr(-,root,root,-)
%{_includedir}/KHR/khrplatform.h
%{_includedir}/EGL/*.h
%{_libdir}/libEGL.so
%{_libdir}/pkgconfig/egl.pc

#=============================================================================
%package		libGL

Summary		:	Mesa libGL runtime libraries

Requires	:	%{name}-libglapi	=	%{version}-%{release}
Requires	:	%{name}-dri-drivers	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libGL
%{summary}

#-----------------------------------------------------------------------------
%files			libGL
%defattr(-,root,root,-)
#provided also by libglvnd-glx?
%{_libdir}/libGL.so.1*
%{_libdir}/libglapi.so

#=============================================================================
%package		libGL-devel

Summary		:	Mesa libGL development package

Requires	:	%{name}-libGL	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libGL-devel
Mesa libGL development package

#-----------------------------------------------------------------------------
%files			libGL-devel
%defattr(-,root,root,-)
%{_includedir}/KHR/khrplatform.h
%{_includedir}/GL/*.h
%{_includedir}/GL/internal/*.h
%{_libdir}/libGL.so
%{_libdir}/libglapi.so
%{_libdir}/pkgconfig/dri.pc
%{_libdir}/pkgconfig/gl.pc

#=============================================================================
%package		libgbm

Summary		:	Mesa gbm runtime library


#-----------------------------------------------------------------------------
%description		libgbm
%{summary}

#-----------------------------------------------------------------------------
%files			libgbm
%defattr(-,root,root,-)
%{_libdir}/libgbm.so.1
%{_libdir}/libgbm.so.1.*

#=============================================================================
%package		libgbm-devel

Summary		:	Mesa libgbm development package

Requires	:	%{name}-libgbm	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libgbm-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libgbm-devel
%defattr(-,root,root,-)
%{_includedir}/gbm.h
%{_libdir}/libgbm.so
%{_libdir}/pkgconfig/gbm.pc

#=============================================================================
%package		libxatracker

Summary		:	Mesa XA runtime libraries


#-----------------------------------------------------------------------------
%description		libxatracker
%{summary}

#-----------------------------------------------------------------------------
%files			libxatracker
%defattr(-,root,root,-)
%{_libdir}/libxatracker.so.2
%{_libdir}/libxatracker.so.2.*

#=============================================================================
%package		libxatracker-devel

Summary		:	Mesa XA state tracker development package

Requires	:	%{name}-libxatracker	=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		libxatracker-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libxatracker-devel
%defattr(-,root,root,-)
%{_includedir}/xa_tracker.h
%{_includedir}/xa_composite.h
%{_includedir}/xa_context.h
%{_libdir}/libxatracker.so
%{_libdir}/pkgconfig/xatracker.pc

#=============================================================================
%package		libOSMesa

Summary		:	Mesa offscreen rendering libraries

#-----------------------------------------------------------------------------
Requires	:       %{name}-libglapi = 	%{version}

#-----------------------------------------------------------------------------
%description		libOSMesa
%{summary}

#-----------------------------------------------------------------------------
%files			libOSMesa
%defattr(-,root,root,-)
%{_libdir}/libOSMesa.so.8*

#=============================================================================
%package		libOSMesa-devel

Summary		:	 Mesa offscreen rendering development package

#-----------------------------------------------------------------------------
Requires	:       %{name}-libOSMesa = 	%{version}

#-----------------------------------------------------------------------------
%description		libOSMesa-devel
%{summary}

#-----------------------------------------------------------------------------
%files			libOSMesa-devel
%defattr(-,root,root,-)
%{_libdir}/libOSMesa.so
%{_libdir}/pkgconfig/osmesa.pc

#=============================================================================
%package		vulkan-drivers

Summary		:	Mesa Vulkan drivers

#-----------------------------------------------------------------------------
%description		vulkan-drivers
The drivers with support for the Vulkan API.

#-----------------------------------------------------------------------------
%files			vulkan-drivers
%defattr(-,root,root,-)
%{_libdir}/libvulkan_intel.so
%{_libdir}/libvulkan_intel_hasvk.so
%{_libdir}/libvulkan_lvp.so
%{_libdir}/libvulkan_nouveau.so
%{_libdir}/libvulkan_radeon.so
%{_datadir}/vulkan/icd.d/*_icd.x86_64.json
%{_datadir}/drirc.d/00-radv-defaults.conf

#=============================================================================
%prep
%setup -q -n %{name}-%{version}
%patch -P 0 -p1

#-----------------------------------------------------------------------------
%build

#GLL_DRV="crocus,i915,iris,nouveau,r300,r600,radeonsi,svga,swrast,virgl,zink"
#GLL_DRV=crocus,i915,iris,nouveau,r300,r600,radeonsi,svga,swrast,virgl
#VUL_DRV=nouveau-experimental,virtio
GLL_DRV=auto
VUL_DRV=auto

meson							\
	setup						\
        --prefix=%{_prefix}				\
	--buildtype=release 				\
	-D platforms=x11,wayland			\
	-D gallium-drivers=${GLL_DRV}			\
	-D vulkan-drivers=${VUL_DRV}			\
	-D valgrind=enabled				\
	-D libunwind=enabled				\
							\
	-D gallium-nine=true				\
	-D glx=dri					\
	-D llvm=enabled 				\
	-D opengl=true					\
	-D osmesa=true					\
	_bld


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja 							\
	-C _bld						\
	%{_smp_mflags}

unset GLL_DRV DIR_DRV

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	ninja						\
	-C _bld						\
	install

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
